/* for CILK */
#include <cilk.h>
#include <cilk-lib.h>
#include <cilk-compat.h>

#  define CILK_PROC_ARGS(type)
#  define CILK_PROC_ARGS0(type) void
#  define CILK_VOID_PROC_ARGS
#  define CILK_VOID_PROC_ARGS0 void
#  define CILK_INLET_PROC_ARGS(a)

#  define USE_SPAWN 
#  define USE_SPAWN_IF_CILK
#  define USE_SPAWN_C(n)

#  define VAR_SPAWN(var, f, args...) var = spawn f(## args)
#  define VAR_SPAWN_IF_CILK(var, f, args...) var = spawn f(## args)
#  define VAR_SPAWN_C(var, f, args...) VAR_SPAWN(var, f, ## args)
#  define VOID_SPAWN(f, args...) spawn f(## args)
#  define VOID_SPAWN_IF_CILK(f, args...) spawn f(## args)
#  define VOID_SPAWN0_IF_CILK(f, args...) spawn f(## args)
#  define VOID_SPAWN_C(f, args...) VOID_SPAWN(f, ## args) 
#  define VAR_SPAWN0(var, f, args...) var = spawn f(## args)
#  define VAR_SPAWN0_C(var, f, args...) VAR_SPAWN0(var, f, ## args) 
#  define VOID_SPAWN0(f, args...) spawn f(## args)
#  define VAR_ADD_SPAWN(var, f, args...) var += spawn f(## args)
#  define VOID_SPAWN0_C(f, args...) VOID_SPAWN0(f, ## args) 

#  define RETURN(x) return(x)
#  define VOID_RETURN return
#  define ATOMIC_ADD_RETURN(a) return(a)

#  define SYNC_IF_CILK sync /* hack to update timers */
#  define LAST_SYNC_IF_CILK sync /* hack to update timers */
#  define SYNC sync
#  define SYNC_C(n) sync
#  define LAST_SYNC sync

#  define MAIN cilk_main
#  define ST_POLLING() 
#  define alloca_exp_free(a, b) 
